<div id="body" class="container-fluid">
  <h6>SLA Entry Form</h6>
  <dx-data-grid #grid id="grid" [dataSource]="items" keyExpr="msSlaId" [columnAutoWidth]="true"
                [rowAlternationEnabled]="true" [showBorders]="true" [wordWrapEnabled]="true"
                (onSelectionChanged)="selectionChangedHandler($event)"
                (onEditingStart)="loadEditForm($event)"
                (onToolbarPreparing)="onToolbarPreparing($event)"
                (onContentReady)="grid.instance.searchByText(grid.searchPanel.text.trim())"
                (onRowInserting)="saveForm($event)" (onRowUpdating)="saveForm($event)">
    <dxo-sorting mode="multiple"></dxo-sorting>
    <dxo-selection mode="multiple" showCheckBoxesMode="always" selectAllMode="page"></dxo-selection>
    <dxo-scrolling mode="standard" showScrollbar="always" useNative="false"></dxo-scrolling>
    <dxo-editing mode="form" [useIcons]="true" [allowUpdating]="true">
      <dxo-form>
        <dxi-item dataField="slaInDayQty" [colSpan]="1"></dxi-item>
      </dxo-form>
    </dxo-editing>
    <dxo-paging [pageSize]="50"></dxo-paging>
    <dxo-pager [showPageSizeSelector]="true" [allowedPageSizes]="[25, 50, 100]"></dxo-pager>
    <dxo-search-panel [visible]="true" [highlightCaseSensitive]="true"></dxo-search-panel>
    <dxi-column type="buttons" [buttons]="['edit']" headerCellTemplate="editHeaderTemplate"></dxi-column>

    <dxi-column dataField="pltfrmCd" caption="Product or Platform">
      <dxi-validation-rule type="required"></dxi-validation-rule>
      <dxo-lookup [dataSource]="pltfrm" valueExpr="pltfrmCd" displayExpr="pltfrmNme">
      </dxo-lookup>
    </dxi-column>
    <dxi-column dataField="msId" caption="Begin Milestone">
      <dxi-validation-rule type="required"></dxi-validation-rule>
      <dxo-lookup [dataSource]="ms" valueExpr="msId" displayExpr="msDes">
      </dxo-lookup>
    </dxi-column>

    <dxi-column dataField="toMsId" caption="End Milestone">
      <dxi-validation-rule type="required"></dxi-validation-rule>
      <dxo-lookup [dataSource]="ms" valueExpr="msId" displayExpr="msDes">
      </dxo-lookup>
    </dxi-column>
    <dxi-column dataField="slaInDayQty" caption="SLA in Days" dataType="number" alignment="left">
      <!--<dxi-validation-rule type="required"></dxi-validation-rule>-->
      <dxi-validation-rule type="numeric"></dxi-validation-rule>
    </dxi-column>
    <dxi-column dataField="creatByUserId" caption="Modified By" dataType="number">
      <dxi-validation-rule type="required"></dxi-validation-rule>
      <dxo-lookup [dataSource]="userData" valueExpr="userId" displayExpr="fullNme">
      </dxo-lookup>
    </dxi-column>
    <dxi-column dataField="creatDt" cellTemplate="localStartTime" caption="Modified Date" dataType="string"></dxi-column>
    <div *dxTemplate="let cell of 'localStartTime'">
      <span>{{cell.text | date:'MM/dd/yyyy hh:mm a'}}</span>
    </div>
    <div *dxTemplate="let data of 'editHeaderTemplate'">
      <div>Edit</div>
    </div>
    <div *dxTemplate="let data of 'removeTemplate'">
      <button class="btn btn-sm btn-primary" type="button"
              [disabled]="!selectedItemKeys.length" (click)="deleteRows()">
        Set Selected SLAs To Zero
      </button>
    </div>
  </dx-data-grid>
</div>
